//+------------------------------------------------------------------+
//|                                               EA_Pinbar_EMAs.mq4 |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property strict

//+------------------------------------------------------------------+
//| Variveis Globais                                  |
//+------------------------------------------------------------------+
bool LongOnMarket = false,ShortOnMarket = false;     // Detetou uma Pinbar
bool LongPinbarDetect = false,ShortPinbarDetect = false;     // Detetou uma Pinbar
bool LongTrend,ShortTrend;
int ticket = 0, PositionIndex = 0, NumSellOrders = 0, NumBuyOrders = 0;   //  <-- this variable will hold the number of orders currently in the Trade pool
double OrderPrice = 0.0;
double StopLossValue, TakeProfitValue, TrailingStop;
double CandleBody, CandleSizePips;     // Clculo do corpo da vela  // Clculo da vela
double ShortEMA, ShortEMA_P, LongEMA, LongEMA_P, VLongEMA, VLongEMA_P;
datetime dtLastbar, dtCurbar; //Open time of last bar   // Open time of current bar
int iMagicNum = 19820506;
double dStoch_Value, dStoch_Signal;

//+------------------------------------------------------------------+
//| Variveis Externas e Internas (Optimizao)                                  |
//+------------------------------------------------------------------+
extern double dPinbarBodyDef = 0.33;   // Tamanho mximo do corpo da vela (30%)
extern double dPinbarTailDef = 0.60;    // Tamanho mximo da cauda da vela (40%)
extern double dTradeRisk = 2.0;        // Valor do risco mximo por trade (2% do capital da conta)
extern int iEMA_short = 8; 
extern int iEMA_long = 21;
extern int iEMA_vlong = 50;
extern bool bPinBar_Active = true, bEMAs_Active = true, bStoch_Active = true;
extern int iStoch_KPeriod = 5;
extern int iStoch_DPeriod = 3;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   dtLastbar = Time[1];//Open time of last bar
   LongOnMarket = false;
   ShortOnMarket = false;
//--- Generate an unique number for each symbol
   if (Symbol() == "EURUSD") iMagicNum= iMagicNum + 1 + Period();
   else if (Symbol() == "EURCAD") iMagicNum= iMagicNum + 2 + Period();
   else if (Symbol() == "EURGBP") iMagicNum= iMagicNum + 3 + Period();
   else Print ("Nenhum Simbolo Seleccionado");
   
   Print ("Simbolo: ", Symbol(), "Nmero Mgico: ", iMagicNum);
//---
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
   {
//--- Variveis 
   double dCandleRatio, dLots = 0.0;
   int iStopLossPips = 0;
   
   if (NewBarDetection()) //Aes a realizar no incio de cada vela japonesa
      {
      //Clculos para a vela actual
      CandleSizePips = NormalizeDouble(High[1]-Low[1],Digits()); //Se for para Forex com 4 casas decimais
      CandleBody = NormalizeDouble(MathAbs(Close[1]-Open[1]),Digits());
      dCandleRatio = NormalizeDouble((CandleBody/CandleSizePips)*100,2);
      Print("Dados da vela: CandleSizePips:", CandleSizePips, " CandleBody:",CandleBody,""," CandleBody/CandleSize:",dCandleRatio,"%");
      //clculos para as mdias      
      ShortEMA_P = iMA(NULL,0,iEMA_short,0,MODE_EMA,PRICE_CLOSE,1);  //Indicador curto no dia anterior
      LongEMA_P = iMA(NULL,0,iEMA_long,0,MODE_EMA,PRICE_CLOSE,1);    //Indicador longo no dia anterior
      VLongEMA_P = iMA(NULL,0,iEMA_vlong,0,MODE_EMA,PRICE_CLOSE,1);  //Indicador muito longo no dia anterior
      //clculo dos estocsticos
      dStoch_Value = iStochastic(NULL,0,iStoch_KPeriod,iStoch_DPeriod,3, MODE_EMA,1,0,1);
      dStoch_Signal = iStochastic(NULL,0,iStoch_KPeriod,iStoch_DPeriod,3, MODE_EMA,1,1,1);
      
      
      //Deteo de Eventos
      Event_Detection();
      
      //Event_Handling();
      if (LongPinbarDetect == 1 && LongTrend == 1 && LongOnMarket == 0 && ShortOnMarket == 0)// && dStoch_Value > dStoch_Signal
         {
         dLots = CalculaLots (CandleSizePips,dTradeRisk);
         BuyLongPosition (dLots);
         if(!ObjectCreate("ARROW BUY Obj: "+TimeToString(Time[1],TIME_DATE|TIME_MINUTES), OBJ_ARROW_UP, 0, Time[1], Low[1]))
            {
            Print("Erro: No foi possvel criar Seta Long! code:",GetLastError());
            };
         }
      if (ShortPinbarDetect == 1 && ShortTrend == 1 && LongOnMarket == 0 && ShortOnMarket == 0)//&& dStoch_Value < dStoch_Signal
         {
         dLots = CalculaLots (CandleSizePips,dTradeRisk);
         BuyShortPosition (dLots);
         if(!ObjectCreate("ARROW SELL Obj: "+TimeToString(Time[1],TIME_DATE|TIME_MINUTES), OBJ_ARROW_DOWN, 0, Time[1], High[1] + 0.001))
            {
            Print("Erro: No foi possvel criar Seta Sell! code :",GetLastError());
            }
         }

      }   //NewBarDetection

//----Gesto de Trailing Stop
   if(LongOnMarket == 1)
     {
      if( Close[1] > TrailingStop)
        {
        TrailingStopOrder();
        //StopLossValue = OrderPrice;
        }
     }
   if(ShortOnMarket == 1)
     {
      if( Close[1] < TrailingStop)
        {
        TrailingStopOrder();
        //StopLossValue = OrderPrice;
        }
     }

  }
//+------------------------------------------------------------------+
//| Funes Auxiliares                                            |
//+------------------------------------------------------------------+

//--------------------- Detecta abertura de nova barra --------------------------//
bool NewBarDetection()
   { 
   dtCurbar = Time[1]; // Open time of current bar

   if (dtLastbar != dtCurbar) 
      { 
      dtLastbar = dtCurbar;
      Print("Nova Barra");
      
      NumBuyOrders = 0;
      NumSellOrders = 0;   //Inicializar os contadores
      
      for(PositionIndex= OrdersTotal()-1; PositionIndex >= 0; PositionIndex--)
      {
         if(OrderSelect(PositionIndex, SELECT_BY_POS) && OrderMagicNumber() == iMagicNum && OrderSymbol() == Symbol())
         {
            if(OrderType() == OP_BUY)  NumBuyOrders++;
            if(OrderType() == OP_SELL) NumSellOrders++;
         } 
      }         
      Print("Buy Orders: ", NumBuyOrders, "Sell Orders: ", NumSellOrders);
      if(NumBuyOrders >= 1 && NumSellOrders == 0)
         {
         LongOnMarket = true;
         ShortOnMarket = false;
         }
      else if(NumBuyOrders == 0 && NumSellOrders >= 1)
         {
         LongOnMarket = false;
         ShortOnMarket = true;
         }
      else
         {
         LongOnMarket = false;
         ShortOnMarket = false;
         }
  
      return (true); 
      }
      else return(false);

   }
//+------------------------------------------------------------------+
//-------------- Detecta existncia de eventos de compra/compra ---------------//
//+------------------------------------------------------------------+
void Event_Detection()
   {
   //Deteo do Pinbar
   if (((CandleBody/CandleSizePips) <= dPinbarBodyDef) && bPinBar_Active == 1) //Corpo da vela <= 30% do tamanho
      {
       //detecao de pinbar longo 
       if((Close[1] > Open[1]) && (Open[1]>= dPinbarTailDef * CandleSizePips + Low[1]) && (Open[1] - Low[1] >= 2*CandleBody))
         {
          LongPinbarDetect = true;
          ShortPinbarDetect = false;
          Print("Pinbar Longo Positivo - Data e Hora: ",iTime(NULL,0,1),"High: ", iHigh(NULL,0,1),"Low: ",iLow(NULL,0,1),2);
         }
       else if((Close[1] < Open[1]) && (Close[1]>= dPinbarTailDef * CandleSizePips + Low[1]) && (Close[1] - Low[1] >= 2*CandleBody))
         {
          LongPinbarDetect = true;
          ShortPinbarDetect = false;
          Print("Pinbar Longo Negativo - Data e Hora: ",iTime(NULL,0,1),"High: ", iHigh(NULL,0,1),"Low: ",iLow(NULL,0,1),2);
         }
       //detecao de pinbar curto 
       else if((Close[1] > Open[1]) && (Close[1] <= High[1] - dPinbarTailDef * CandleSizePips) && (High[1] - Close[1] >= 2*CandleBody))
         {
          LongPinbarDetect = false;
          ShortPinbarDetect = true;
          Print("Pinbar Curto Positivo - Data e Hora: ",iTime(NULL,0,1),"High: ", iHigh(NULL,0,1),"Low: ",iLow(NULL,0,1),2);
         }
       else if((Close[1] < Open[1]) && (Open[1] <= High[1] - dPinbarTailDef * CandleSizePips) && (High[1] - Open[1] >= 2*CandleBody))
         {
          LongPinbarDetect = false;
          ShortPinbarDetect = true;
          Print("Pinbar Curto Negativo - Data e Hora: ",iTime(NULL,0,1),"High: ", iHigh(NULL,0,1),"Low: ",iLow(NULL,0,1),2);
         }
       else  
         {
         LongPinbarDetect = false;
         ShortPinbarDetect = false;      
         }
      }
      else  
         {
         LongPinbarDetect = false;
         ShortPinbarDetect = false;      
         }
         
   //Deteo da trend
   if(bEMAs_Active == 1)
     {
      if((VLongEMA_P < LongEMA_P) && (LongEMA_P< ShortEMA_P))//VLongEMA_P < LongEMA_P < ShortEMA_P
        {
         LongTrend = true;
         ShortTrend = false;
         Print("EMAs - Trend Positiva:", NormalizeDouble(VLongEMA_P,3), " < ", NormalizeDouble(LongEMA_P,3), " < ",NormalizeDouble(ShortEMA_P,3));
        }
      else if((VLongEMA_P > LongEMA_P) && (LongEMA_P> ShortEMA_P))//VLongEMA_P > LongEMA_P > ShortEMA_P
        {
         LongTrend = false;
         ShortTrend = true;
         Print("EMAs - Trend Negativa:", NormalizeDouble(VLongEMA_P,3), " > ", NormalizeDouble(LongEMA_P,3), " > ",NormalizeDouble(ShortEMA_P,3));
        }
      else 
        {
         LongTrend = false;
         ShortTrend = false;
         Print("EMAs - Trend Indefinida");
        }
     }
     
     //Verificao do estocstico
     /*if(bStoch_Active == 1)
       {
        if(dStoch >= 90.0)
          {
           
          }
       }*/
   }
//--------------------------- Clculo dos Lotes ---------------------------------//
double CalculaLots(double CandlePips, double dRiskManage) 
   {
   double dAuxLots;
   double dQuote_EURUSD;
   double dMoneyRisk;
   int iStopLossPips;
   
   iStopLossPips = int (CandlePips * 100000.0);// Necessrio validar o tamanho do lote ou do contrato. https://forum.mql4.com/59734  https://www.mql5.com/en/articles/113
   dQuote_EURUSD = MarketInfo("EURUSD",MODE_TICKVALUE);
   dMoneyRisk = AccountFreeMargin() * dRiskManage / 100.0;
  // http://forum.mql4.com/15663    StopLoss
  
   dAuxLots = (dMoneyRisk / iStopLossPips)/dQuote_EURUSD;
   //dAuxLots = 0.1;

   if (dAuxLots < 0.1)
   {
      dAuxLots = 0.1;
   }
   else
   {
      dAuxLots = NormalizeDouble (dAuxLots, 1);
      //AuxLots = 0.1;
   }
   Print("Gesto de Risco: StopLoss em  = ", dMoneyRisk, " Quote_EURUSD:",dQuote_EURUSD, "Lotes", dAuxLots);
   Print ("Account: ", AccountNumber(), " leverage is: ", AccountLeverage(), " Lote Mnimo: ", MarketInfo(Symbol(),MODE_LOTSIZE));
   return (dAuxLots);
   }

//--------------------- Efetua a compra de posies longas --------------------------//
void BuyLongPosition(double lots)
   {
   StopLossValue = Ask - CandleSizePips -0.0001; //-0.0001  o preo do SPREAD
   TakeProfitValue = Ask + 2*CandleSizePips -0.0001;
   TrailingStop = Ask + CandleSizePips +0.0001;
   //ticket = OrderSend(Symbol(),OP_BUYLIMIT,lots,Ask-(CandleSizePips*0.5),3,StopLossValue,TakeProfitValue,"Compra Longos",iMagicNum,0,Blue);
   ticket = OrderSend(Symbol(),OP_BUY,lots,Ask,3,StopLossValue,TakeProfitValue,"Compra Longos",iMagicNum,0,Blue);
   if(ticket<0)
      {
      Print("Ordem Falhada por Erro:# ",GetLastError());
      }
   else
      {
      if(OrderSelect(ticket,SELECT_BY_TICKET)==true){OrderPrice = OrderClosePrice();}
      LongOnMarket = true;
      ShortOnMarket = false;
      Print("Ordem Bem Sucedida: ticket =",ticket, "ClosePrice", OrderPrice, "StopLoss", StopLossValue, "Takeprofit", TakeProfitValue);
      }
   }
   
//--------------------- Efetua a compra de posies curtas --------------------------//
void BuyShortPosition(double lots)
   {
   StopLossValue = Bid + CandleSizePips -0.0001;
   TakeProfitValue = Bid - 2*CandleSizePips -0.0001;
   TrailingStop = Bid - CandleSizePips -0.0001;
   //ticket = OrderSend(Symbol(),OP_SELLLIMIT,lots,Bid+(CandleSizePips*0.5),3,StopLossValue,TakeProfitValue,"Compra Curtos",iMagicNum,0,Red);
   ticket = OrderSend(Symbol(),OP_SELL,lots,Bid,3,StopLossValue,TakeProfitValue,"Compra Curtos",iMagicNum,0,Red);
   if(ticket<0)
      {
      Print("Ordem Falhada por Erro:# ",GetLastError());
      }
   else
      {
      if(OrderSelect(ticket,SELECT_BY_TICKET)==true){OrderPrice = OrderClosePrice();}
      ShortOnMarket = true;
      LongOnMarket = false;
      Print("Ordem Bem Sucedida: ticket =",ticket, "ClosePrice", OrderPrice, "StopLoss", StopLossValue, "Takeprofit", TakeProfitValue);

      }
   }
//--------------------- Trailing Stop --------------------------//
void TrailingStopOrder ()
   {
   if(OrderSelect(ticket,SELECT_BY_TICKET)==true)
      {
      Print("Ordem seleccionada - Ticket Correto");
      OrderPrice = OrderClosePrice();
      TakeProfitValue = OrderTakeProfit();
      
      if(OrderModify(ticket,OrderClosePrice(),OrderClosePrice(),TakeProfitValue,0,Green))
        {
         Print("Ordem de modificao bem sucedida:Trailing Stop Ajustado");
        }
      else Print("Erro: Ordem de modificao mal executada!!");
      }
   else Print("Ordem seleccionada - Ticket Correto");
   }
//------------------------------ FECHA ORDENS ABERTAS ------------------------------//

/*bool CloseOpenOrders() 
{ 
Print("N de ordens abertas:# ", OrdersTotal()); 

for(PositionIndex = OrdersTotal() - 1; PositionIndex >= 0 ; PositionIndex --)  //  <-- for loop to loop through all Orders . .   COUNT DOWN TO ZERO !
   {
   if( !OrderSelect(PositionIndex, SELECT_BY_POS, MODE_TRADES) ) continue;   // <-- if the OrderSelect fails advance the loop to the next PositionIndex
   
      if ( !OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(),3) )
         { 
         Print("Ordem Falhada por Erro:# ", OrderTicket(), " Error: ", GetLastError() );  // <-- if the Order Close failed print some helpful information 
         return (false); 
         }
         else
         {
         Print("Ordem fechada correctamente "); 
         if (LongOnMarket == 1) LongOnMarket = 0;
         if (ShortOnMarket == 1) ShortOnMarket = 0;
         return (true); 
      }
   } //  end of For loop 
return(0);
}
*/
